import { ConvertOptions, ParseOptions } from '../types';
export declare function convert({ source, target, original, sourceLanguage, targetLanguage }: ConvertOptions): ParseOptions;
export declare function parse({ content }: ParseOptions): ConvertOptions;
export declare function formatDate(date: Date): string;
export declare function timezoneOffset(date: Date): string;
export declare function gettextComment(prefix: string, value: string, maxCharWidth: number): string;
export declare function gettextString(prefix: string, value: string, maxCharWidth: number): string;
interface GettextEntry {
    translatorCommentLines: string[];
    extractedCommentLines: string[];
    references: string[];
    flags: string[];
    msgctxt: string;
    msgid: string;
    msgstr: string;
}
export interface Gettext extends Array<GettextEntry> {
}
export declare function gettextToJs(content: string): Gettext;
export {};
